//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Server.ConnectionConfiguration
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Enable Server Initiated Connection Mode command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EnableServerInitiatedConnectionModeRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EnableServerInitiatedConnectionModeRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EnableServerInitiatedConnectionModeRequestDto(Tecan.Sila2.IBinaryStore store)
        {
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/core/ConnectionConfigurationService/v1/Command/EnableServerIniti" +
                    "atedConnectionMode";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return null;
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Disable Server Initiated Connection Mode command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class DisableServerInitiatedConnectionModeRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public DisableServerInitiatedConnectionModeRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public DisableServerInitiatedConnectionModeRequestDto(Tecan.Sila2.IBinaryStore store)
        {
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/core/ConnectionConfigurationService/v1/Command/DisableServerInit" +
                    "iatedConnectionMode";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return null;
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Connect SiLA Client command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ConnectSiLAClientRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.StringDto _clientName;
        
        private Tecan.Sila2.StringDto _siLAClientHost;
        
        private Tecan.Sila2.IntegerDto _siLAClientPort;
        
        private Tecan.Sila2.BooleanDto _persist;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public ConnectSiLAClientRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="clientName">Human readable name of the SiLA Client. Has to be unique.</param>
        /// <param name="siLAClientHost">Host Address of the new SiLA Client.</param>
        /// <param name="siLAClientPort">Port of the new SiLA Client.</param>
        /// <param name="persist">Whether or not the connection should be persisted.</param>
        public ConnectSiLAClientRequestDto(string clientName, string siLAClientHost, long siLAClientPort, bool persist, Tecan.Sila2.IBinaryStore store)
        {
            ClientName = new Tecan.Sila2.StringDto(clientName, store);
            SiLAClientHost = new Tecan.Sila2.StringDto(siLAClientHost, store);
            SiLAClientPort = new Tecan.Sila2.IntegerDto(siLAClientPort, store);
            Persist = new Tecan.Sila2.BooleanDto(persist, store);
        }
        
        /// <summary>
        /// Human readable name of the SiLA Client. Has to be unique.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto ClientName
        {
            get
            {
                return _clientName;
            }
            set
            {
                _clientName = value;
            }
        }
        
        /// <summary>
        /// Host Address of the new SiLA Client.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.StringDto SiLAClientHost
        {
            get
            {
                return _siLAClientHost;
            }
            set
            {
                _siLAClientHost = value;
            }
        }
        
        /// <summary>
        /// Port of the new SiLA Client.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(3)]
        public Tecan.Sila2.IntegerDto SiLAClientPort
        {
            get
            {
                return _siLAClientPort;
            }
            set
            {
                _siLAClientPort = value;
            }
        }
        
        /// <summary>
        /// Whether or not the connection should be persisted.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(4)]
        public Tecan.Sila2.BooleanDto Persist
        {
            get
            {
                return _persist;
            }
            set
            {
                _persist = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/core/ConnectionConfigurationService/v1/Command/ConnectSiLAClient" +
                    "";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ClientName, "clientName");
            if ((ClientName.Value.Length > 255))
            {
                throw new ArgumentException(string.Format("ClientName  has length {0} and is longer than allowed length 255", ClientName.Value.Length), "clientName");
            }
            Argument.Validate(SiLAClientHost, "siLAClientHost");
            if ((SiLAClientHost.Value.Length > 255))
            {
                throw new ArgumentException(string.Format("SiLAClientHost  has length {0} and is longer than allowed length 255", SiLAClientHost.Value.Length), "siLAClientHost");
            }
            Argument.Validate(SiLAClientPort, "siLAClientPort");
            if ((SiLAClientPort.Value <= 0))
            {
                throw new ArgumentException(string.Format("SiLAClientPort should have been at least more than 0 but was \'{0}\'", SiLAClientPort.Value), "siLAClientPort");
            }
            if ((SiLAClientPort.Value > 65536))
            {
                throw new ArgumentException(string.Format("SiLAClientPort should have been at most 65536 but was \'{0}\'", SiLAClientPort.Value), "siLAClientPort");
            }
            Argument.Validate(Persist, "persist");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = (((("" + Argument.Require(ClientName, "clientName")) 
                        + Argument.Require(SiLAClientHost, "siLAClientHost")) 
                        + Argument.Require(SiLAClientPort, "siLAClientPort")) 
                        + Argument.Require(Persist, "persist"));
            if ((ClientName.Value.Length > 255))
            {
                errors = (errors + string.Format("ClientName  has length {0} and is longer than allowed length 255", ClientName.Value.Length));
            }
            if ((SiLAClientHost.Value.Length > 255))
            {
                errors = (errors + string.Format("SiLAClientHost  has length {0} and is longer than allowed length 255", SiLAClientHost.Value.Length));
            }
            if ((SiLAClientPort.Value <= 0))
            {
                errors = (errors + string.Format("SiLAClientPort should have been at least more than 0 but was \'{0}\'", SiLAClientPort.Value));
            }
            if ((SiLAClientPort.Value > 65536))
            {
                errors = (errors + string.Format("SiLAClientPort should have been at most 65536 but was \'{0}\'", SiLAClientPort.Value));
            }
            return errors;
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Disconnect SiLA Client command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class DisconnectSiLAClientRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.StringDto _clientName;
        
        private Tecan.Sila2.BooleanDto _remove;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public DisconnectSiLAClientRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="clientName">Human readable name of the SiLA Client.</param>
        /// <param name="remove">Whether or not to remove the connection details.</param>
        public DisconnectSiLAClientRequestDto(string clientName, bool remove, Tecan.Sila2.IBinaryStore store)
        {
            ClientName = new Tecan.Sila2.StringDto(clientName, store);
            Remove = new Tecan.Sila2.BooleanDto(remove, store);
        }
        
        /// <summary>
        /// Human readable name of the SiLA Client.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto ClientName
        {
            get
            {
                return _clientName;
            }
            set
            {
                _clientName = value;
            }
        }
        
        /// <summary>
        /// Whether or not to remove the connection details.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.BooleanDto Remove
        {
            get
            {
                return _remove;
            }
            set
            {
                _remove = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/core/ConnectionConfigurationService/v1/Command/DisconnectSiLACli" +
                    "ent";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ClientName, "clientName");
            if ((ClientName.Value.Length > 255))
            {
                throw new ArgumentException(string.Format("ClientName  has length {0} and is longer than allowed length 255", ClientName.Value.Length), "clientName");
            }
            Argument.Validate(Remove, "remove");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = (("" + Argument.Require(ClientName, "clientName")) 
                        + Argument.Require(Remove, "remove"));
            if ((ClientName.Value.Length > 255))
            {
                errors = (errors + string.Format("ClientName  has length {0} and is longer than allowed length 255", ClientName.Value.Length));
            }
            return errors;
        }
    }
    
    /// <summary>
    /// The data transfer object for Configured Si L A Client
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ConfiguredSiLAClientDto : Tecan.Sila2.ISilaTransferObject<ConfiguredSiLAClient>
    {
        
        private Tecan.Sila2.StringDto _clientName;
        
        private Tecan.Sila2.StringDto _siLAClientHost;
        
        private Tecan.Sila2.IntegerDto _siLAClientPort;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public ConfiguredSiLAClientDto()
        {
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public ConfiguredSiLAClientDto(ConfiguredSiLAClient inner, Tecan.Sila2.IBinaryStore store)
        {
            ClientName = new Tecan.Sila2.StringDto(inner.ClientName, store);
            SiLAClientHost = new Tecan.Sila2.StringDto(inner.SiLAClientHost, store);
            SiLAClientPort = new Tecan.Sila2.IntegerDto(inner.SiLAClientPort, store);
        }
        
        /// <summary>
        /// Human readable name of the SiLA Client.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto ClientName
        {
            get
            {
                return _clientName;
            }
            set
            {
                _clientName = value;
            }
        }
        
        /// <summary>
        /// Host Address of the SiLA Client.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.StringDto SiLAClientHost
        {
            get
            {
                return _siLAClientHost;
            }
            set
            {
                _siLAClientHost = value;
            }
        }
        
        /// <summary>
        /// Port of the SiLA Client.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(3)]
        public Tecan.Sila2.IntegerDto SiLAClientPort
        {
            get
            {
                return _siLAClientPort;
            }
            set
            {
                _siLAClientPort = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public ConfiguredSiLAClient Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new ConfiguredSiLAClient(ClientName.Extract(store), SiLAClientHost.Extract(store), SiLAClientPort.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static ConfiguredSiLAClientDto Create(ConfiguredSiLAClient inner, Tecan.Sila2.IBinaryStore store)
        {
            return new ConfiguredSiLAClientDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ((("" + Argument.Require(ClientName, "clientName")) 
                        + Argument.Require(SiLAClientHost, "siLAClientHost")) 
                        + Argument.Require(SiLAClientPort, "siLAClientPort"));
        }
    }
}
